	component nios_system is
		port (
			audio_conduit_end_XCK          : out   std_logic;                                        -- XCK
			audio_conduit_end_ADCDAT       : in    std_logic                     := 'X';             -- ADCDAT
			audio_conduit_end_ADCLRC       : in    std_logic                     := 'X';             -- ADCLRC
			audio_conduit_end_DACDAT       : out   std_logic;                                        -- DACDAT
			audio_conduit_end_DACLRC       : in    std_logic                     := 'X';             -- DACLRC
			audio_conduit_end_BCLK         : in    std_logic                     := 'X';             -- BCLK
			audio_i2c_export_scl_pad_io    : inout std_logic                     := 'X';             -- scl_pad_io
			audio_i2c_export_sda_pad_io    : inout std_logic                     := 'X';             -- sda_pad_io
			clk_clk                        : in    std_logic                     := 'X';             -- clk
			emif_ref_clk_clk               : in    std_logic                     := 'X';             -- clk
			emif_mem_mem_ck_t              : out   std_logic;                                        -- mem_ck_t
			emif_mem_mem_ck_c              : out   std_logic;                                        -- mem_ck_c
			emif_mem_mem_cke               : out   std_logic;                                        -- mem_cke
			emif_mem_mem_odt               : out   std_logic;                                        -- mem_odt
			emif_mem_mem_cs_n              : out   std_logic;                                        -- mem_cs_n
			emif_mem_mem_a                 : out   std_logic_vector(16 downto 0);                    -- mem_a
			emif_mem_mem_ba                : out   std_logic_vector(1 downto 0);                     -- mem_ba
			emif_mem_mem_bg                : out   std_logic;                                        -- mem_bg
			emif_mem_mem_act_n             : out   std_logic;                                        -- mem_act_n
			emif_mem_mem_par               : out   std_logic;                                        -- mem_par
			emif_mem_mem_alert_n           : in    std_logic                     := 'X';             -- mem_alert_n
			emif_mem_mem_reset_n           : out   std_logic;                                        -- mem_reset_n
			emif_mem_mem_dq                : inout std_logic_vector(31 downto 0) := (others => 'X'); -- mem_dq
			emif_mem_mem_dqs_t             : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs_t
			emif_mem_mem_dqs_c             : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs_c
			emif_mem_mem_dbi_n             : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dbi_n
			emif_oct_oct_rzqin             : in    std_logic                     := 'X';             -- oct_rzqin
			key_external_connection_export : in    std_logic_vector(3 downto 0)  := (others => 'X'); -- export
			led_external_connection_export : out   std_logic_vector(9 downto 0);                     -- export
			sw_external_connection_export  : in    std_logic_vector(9 downto 0)  := (others => 'X'); -- export
			reset_reset_n                  : in    std_logic                     := 'X';             -- reset_n
			seg7_conduit_end_export        : out   std_logic_vector(47 downto 0)                     -- export
		);
	end component nios_system;

	u0 : component nios_system
		port map (
			audio_conduit_end_XCK          => CONNECTED_TO_audio_conduit_end_XCK,          --       audio_conduit_end.XCK
			audio_conduit_end_ADCDAT       => CONNECTED_TO_audio_conduit_end_ADCDAT,       --                        .ADCDAT
			audio_conduit_end_ADCLRC       => CONNECTED_TO_audio_conduit_end_ADCLRC,       --                        .ADCLRC
			audio_conduit_end_DACDAT       => CONNECTED_TO_audio_conduit_end_DACDAT,       --                        .DACDAT
			audio_conduit_end_DACLRC       => CONNECTED_TO_audio_conduit_end_DACLRC,       --                        .DACLRC
			audio_conduit_end_BCLK         => CONNECTED_TO_audio_conduit_end_BCLK,         --                        .BCLK
			audio_i2c_export_scl_pad_io    => CONNECTED_TO_audio_i2c_export_scl_pad_io,    --        audio_i2c_export.scl_pad_io
			audio_i2c_export_sda_pad_io    => CONNECTED_TO_audio_i2c_export_sda_pad_io,    --                        .sda_pad_io
			clk_clk                        => CONNECTED_TO_clk_clk,                        --                     clk.clk
			emif_ref_clk_clk               => CONNECTED_TO_emif_ref_clk_clk,               --            emif_ref_clk.clk
			emif_mem_mem_ck_t              => CONNECTED_TO_emif_mem_mem_ck_t,              --                emif_mem.mem_ck_t
			emif_mem_mem_ck_c              => CONNECTED_TO_emif_mem_mem_ck_c,              --                        .mem_ck_c
			emif_mem_mem_cke               => CONNECTED_TO_emif_mem_mem_cke,               --                        .mem_cke
			emif_mem_mem_odt               => CONNECTED_TO_emif_mem_mem_odt,               --                        .mem_odt
			emif_mem_mem_cs_n              => CONNECTED_TO_emif_mem_mem_cs_n,              --                        .mem_cs_n
			emif_mem_mem_a                 => CONNECTED_TO_emif_mem_mem_a,                 --                        .mem_a
			emif_mem_mem_ba                => CONNECTED_TO_emif_mem_mem_ba,                --                        .mem_ba
			emif_mem_mem_bg                => CONNECTED_TO_emif_mem_mem_bg,                --                        .mem_bg
			emif_mem_mem_act_n             => CONNECTED_TO_emif_mem_mem_act_n,             --                        .mem_act_n
			emif_mem_mem_par               => CONNECTED_TO_emif_mem_mem_par,               --                        .mem_par
			emif_mem_mem_alert_n           => CONNECTED_TO_emif_mem_mem_alert_n,           --                        .mem_alert_n
			emif_mem_mem_reset_n           => CONNECTED_TO_emif_mem_mem_reset_n,           --                        .mem_reset_n
			emif_mem_mem_dq                => CONNECTED_TO_emif_mem_mem_dq,                --                        .mem_dq
			emif_mem_mem_dqs_t             => CONNECTED_TO_emif_mem_mem_dqs_t,             --                        .mem_dqs_t
			emif_mem_mem_dqs_c             => CONNECTED_TO_emif_mem_mem_dqs_c,             --                        .mem_dqs_c
			emif_mem_mem_dbi_n             => CONNECTED_TO_emif_mem_mem_dbi_n,             --                        .mem_dbi_n
			emif_oct_oct_rzqin             => CONNECTED_TO_emif_oct_oct_rzqin,             --                emif_oct.oct_rzqin
			key_external_connection_export => CONNECTED_TO_key_external_connection_export, -- key_external_connection.export
			led_external_connection_export => CONNECTED_TO_led_external_connection_export, -- led_external_connection.export
			sw_external_connection_export  => CONNECTED_TO_sw_external_connection_export,  --  sw_external_connection.export
			reset_reset_n                  => CONNECTED_TO_reset_reset_n,                  --                   reset.reset_n
			seg7_conduit_end_export        => CONNECTED_TO_seg7_conduit_end_export         --        seg7_conduit_end.export
		);

