// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// $Id: //acds/rel/23.4/ip/iconnect/merlin/altera_merlin_router/altera_merlin_router.sv.terp#1 $
// $Revision: #1 $
// $Date: 2023/10/12 $

// -------------------------------------------------------
// Merlin Router
//
// Asserts the appropriate one-hot encoded channel based on 
// the address.
//
// Also sets the binary-encoded destination id.
// -------------------------------------------------------

`timescale 1 ns / 1 ns

// ------------------------------------------
// Generation parameters:
//    decoder_type            0 (address decoder)
//    default_channel         3
//    default_destid          18
//    default_rd_channel      -1
//    default_wr_channel      -1
//    has_default_slave       0
//    memory_aliasing_decode  0
//    output_name             system_altera_merlin_router_1921_sflbyhi
//    pkt_addr_h              56
//    pkt_addr_l              36
//    pkt_dest_id_h           87
//    pkt_dest_id_l           83
//    pkt_protection_h        91
//    pkt_protection_l        89
//    pkt_trans_read          60
//    pkt_trans_write         59
//    slaves_info             18:000000000000000001000:0x80000:0x100000:both:1:0:0:1,17:000000000000000000100:0x100800:0x101000:both:1:0:0:1,20:000100000000000000000:0x101000:0x101020:both:1:0:0:1,6:000000000100000000000:0x101020:0x101030:read:1:0:0:1,5:000000000010000000000:0x101030:0x101040:read:1:0:0:1,1:000000000001000000000:0x101040:0x101050:read:1:0:0:1,0:000000000000100000000:0x101050:0x101060:read:1:0:0:1,2:000000000000001000000:0x101060:0x101070:read:1:0:0:1,3:000000000000010000000:0x101070:0x101080:read:1:0:0:1,10:000000000000000010000:0x101080:0x101090:read:1:0:0:1,7:000000000000000100000:0x101090:0x1010a0:read:1:0:0:1,4:000000001000000000000:0x1010a0:0x1010b0:read:1:0:0:1,12:000000010000000000000:0x1010b0:0x1010c0:read:1:0:0:1,13:000000100000000000000:0x1010c0:0x1010d0:read:1:0:0:1,14:000010000000000000000:0x1010d0:0x1010e0:read:1:0:0:1,15:100000000000000000000:0x1010e0:0x1010f0:read:1:0:0:1,9:010000000000000000000:0x1010f0:0x101100:read:1:0:0:1,8:000001000000000000000:0x101100:0x101110:read:1:0:0:1,19:000000000000000000010:0x101110:0x101118:read:1:0:0:1,16:000000000000000000001:0x101118:0x101120:both:1:0:0:1,11:001000000000000000000:0x101130:0x101140:read:1:0:0:1
//    st_channel_w            21
//    st_data_w               123
// ------------------------------------------

module system_altera_merlin_router_1921_sflbyhi_default_decode
  #(
     parameter DEFAULT_CHANNEL = 3,
               DEFAULT_WR_CHANNEL = -1,
               DEFAULT_RD_CHANNEL = -1,
               DEFAULT_DESTID = 18 
   )
  (output [87 - 83 : 0] default_destination_id,
   output [21-1 : 0] default_wr_channel,
   output [21-1 : 0] default_rd_channel,
   output [21-1 : 0] default_src_channel
  );

  assign default_destination_id = 
    DEFAULT_DESTID[87 - 83 : 0];

  generate
    if (DEFAULT_CHANNEL == -1) begin : no_default_channel_assignment
      assign default_src_channel = '0;
    end
    else begin : default_channel_assignment
      assign default_src_channel = 21'b1 << DEFAULT_CHANNEL;
    end
  endgenerate

  generate
    if (DEFAULT_RD_CHANNEL == -1) begin : no_default_rw_channel_assignment
      assign default_wr_channel = '0;
      assign default_rd_channel = '0;
    end
    else begin : default_rw_channel_assignment
      assign default_wr_channel = 21'b1 << DEFAULT_WR_CHANNEL;
      assign default_rd_channel = 21'b1 << DEFAULT_RD_CHANNEL;
    end
  endgenerate

endmodule


module system_altera_merlin_router_1921_sflbyhi
(
    // -------------------
    // Clock & Reset
    // -------------------
    input clk,
    input reset,

    // -------------------
    // Command Sink (Input)
    // -------------------
    input                       sink_valid,
    input  [123-1 : 0]    sink_data,
    input                       sink_startofpacket,
    input                       sink_endofpacket,
    output                      sink_ready,

    // -------------------
    // Command Source (Output)
    // -------------------
    output                          src_valid,
    output reg [123-1    : 0] src_data,
    output reg [21-1 : 0] src_channel,
    output                          src_startofpacket,
    output                          src_endofpacket,
    input                           src_ready
);

    // -------------------------------------------------------
    // Local parameters and variables
    // -------------------------------------------------------
    localparam PKT_ADDR_H = 56;
    localparam PKT_ADDR_L = 36;
    localparam PKT_DEST_ID_H = 87;
    localparam PKT_DEST_ID_L = 83;
    localparam PKT_PROTECTION_H = 91;
    localparam PKT_PROTECTION_L = 89;
    localparam ST_DATA_W = 123;
    localparam ST_CHANNEL_W = 21;
    localparam DECODER_TYPE = 0;

    localparam PKT_TRANS_WRITE = 59;
    localparam PKT_TRANS_READ  = 60;

    localparam PKT_ADDR_W = PKT_ADDR_H-PKT_ADDR_L + 1;
    localparam PKT_DEST_ID_W = PKT_DEST_ID_H-PKT_DEST_ID_L + 1;



    // -------------------------------------------------------
    // Figure out the number of bits to mask off for each slave span
    // during address decoding
    // -------------------------------------------------------
    // -------------------------------------------------------
    // Work out which address bits are significant based on the
    // address range of the slaves. If the required width is too
    // large or too small, we use the address field width instead.
    // -------------------------------------------------------
    localparam ADDR_RANGE = 64'h101140;
    localparam RANGE_ADDR_WIDTH = log2ceil(ADDR_RANGE);
    localparam OPTIMIZED_ADDR_H = (RANGE_ADDR_WIDTH > PKT_ADDR_W) ||
                                  (RANGE_ADDR_WIDTH == 0) ?
                                        PKT_ADDR_H :
                                        PKT_ADDR_L + RANGE_ADDR_WIDTH - 1;

    localparam REAL_ADDRESS_RANGE = OPTIMIZED_ADDR_H - PKT_ADDR_L;

      reg [PKT_ADDR_W-1 : 0] address;
      always @* begin
        address = {PKT_ADDR_W{1'b0}};
        address [REAL_ADDRESS_RANGE:0] = sink_data[OPTIMIZED_ADDR_H : PKT_ADDR_L];
      end   

    // -------------------------------------------------------
    // Pass almost everything through, untouched
    // -------------------------------------------------------
    assign sink_ready        = src_ready;
    assign src_valid         = sink_valid;
    assign src_startofpacket = sink_startofpacket;
    assign src_endofpacket   = sink_endofpacket;
    wire [PKT_DEST_ID_W-1:0] default_destid;
    wire [21-1 : 0] default_src_channel;




    // -------------------------------------------------------
    // Write and read transaction signals
    // -------------------------------------------------------
    wire read_transaction;
    assign read_transaction  = sink_data[PKT_TRANS_READ];


    system_altera_merlin_router_1921_sflbyhi_default_decode the_default_decode(
      .default_destination_id (default_destid),
      .default_wr_channel   (),
      .default_rd_channel   (),
      .default_src_channel  (default_src_channel)
    );

    always @* begin
        src_data    = sink_data;
        src_channel = default_src_channel;
        src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = default_destid;

        // --------------------------------------------------
        // Address Decoder
        // Sets the channel and destination ID based on the address
        // --------------------------------------------------

        // slave 0: [0x80000, 0x100000) : sel [20:19]
        if ( {address[20:19],{19 {1'b0}}} == 21'h80000   ) begin
            src_channel = 21'b000000000000000001000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 18;
        end

        // slave 1: [0x100800, 0x101000) : sel [20:11]
        if ( {address[20:11],{11 {1'b0}}} == 21'h100800   ) begin
            src_channel = 21'b000000000000000000100;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 17;
        end

        // slave 2: [0x101000, 0x101020) : sel [20:5]
        if ( {address[20:5],{5 {1'b0}}} == 21'h101000   ) begin
            src_channel = 21'b000100000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 20;
        end

        // slave 3: [0x101020, 0x101030) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101020  && read_transaction  ) begin
            src_channel = 21'b000000000100000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 6;
        end

        // slave 4: [0x101030, 0x101040) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101030  && read_transaction  ) begin
            src_channel = 21'b000000000010000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 5;
        end

        // slave 5: [0x101040, 0x101050) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101040  && read_transaction  ) begin
            src_channel = 21'b000000000001000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 1;
        end

        // slave 6: [0x101050, 0x101060) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101050  && read_transaction  ) begin
            src_channel = 21'b000000000000100000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 0;
        end

        // slave 7: [0x101060, 0x101070) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101060  && read_transaction  ) begin
            src_channel = 21'b000000000000001000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 2;
        end

        // slave 8: [0x101070, 0x101080) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101070  && read_transaction  ) begin
            src_channel = 21'b000000000000010000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 3;
        end

        // slave 9: [0x101080, 0x101090) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101080  && read_transaction  ) begin
            src_channel = 21'b000000000000000010000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 10;
        end

        // slave 10: [0x101090, 0x1010a0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101090  && read_transaction  ) begin
            src_channel = 21'b000000000000000100000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 7;
        end

        // slave 11: [0x1010a0, 0x1010b0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010a0  && read_transaction  ) begin
            src_channel = 21'b000000001000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 4;
        end

        // slave 12: [0x1010b0, 0x1010c0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010b0  && read_transaction  ) begin
            src_channel = 21'b000000010000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 12;
        end

        // slave 13: [0x1010c0, 0x1010d0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010c0  && read_transaction  ) begin
            src_channel = 21'b000000100000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 13;
        end

        // slave 14: [0x1010d0, 0x1010e0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010d0  && read_transaction  ) begin
            src_channel = 21'b000010000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 14;
        end

        // slave 15: [0x1010e0, 0x1010f0) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010e0  && read_transaction  ) begin
            src_channel = 21'b100000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 15;
        end

        // slave 16: [0x1010f0, 0x101100) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h1010f0  && read_transaction  ) begin
            src_channel = 21'b010000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 9;
        end

        // slave 17: [0x101100, 0x101110) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101100  && read_transaction  ) begin
            src_channel = 21'b000001000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 8;
        end

        // slave 18: [0x101110, 0x101118) : sel [20:3]
        if ( {address[20:3],{3 {1'b0}}} == 21'h101110  && read_transaction  ) begin
            src_channel = 21'b000000000000000000010;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 19;
        end

        // slave 19: [0x101118, 0x101120) : sel [20:3]
        if ( {address[20:3],{3 {1'b0}}} == 21'h101118   ) begin
            src_channel = 21'b000000000000000000001;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 16;
        end

        // slave 20: [0x101130, 0x101140) : sel [20:4]
        if ( {address[20:4],{4 {1'b0}}} == 21'h101130  && read_transaction  ) begin
            src_channel = 21'b001000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 11;
        end
    end


    // --------------------------------------------------
    // Ceil(log2()) function
    // It's the 21st century. Consider using $clog2().
    // --------------------------------------------------
    function integer log2ceil;
        input reg[65:0] val;
        reg [65:0] i;

        begin
            i = 1;
            log2ceil = 0;

            while (i < val) begin
                log2ceil = log2ceil + 1;
                i = i << 1;
            end
        end
    endfunction

endmodule


